import networkx as nx

rj = nx.Graph()
rj.add_edge("Juliet", "Nurse")
rj.add_edge("Juliet", "Tybalt")
rj.add_edge("Juliet", "Capulet")
rj.add_edge("Juliet", "Friar Laurence")
rj.add_edge("Juliet", "Romeo")
rj.add_edge("Capulet", "Tybalt")
rj.add_edge("Capulet", "Paris")
rj.add_edge("Capulet", "Escalus")
rj.add_edge("Romeo", "Friar Laurence")
rj.add_edge("Romeo", "Benvolio")
rj.add_edge("Romeo", "Montague")
rj.add_edge("Romeo", "Mercutio")
rj.add_edge("Montague", "Benvolio")
rj.add_edge("Montague", "Escalus")
rj.add_edge("Mercutio", "Escalus")
rj.add_edge("Mercutio", "Paris")
rj.add_edge("Escalus", "Paris")


def friends(graph, user):
    """Returns a set of the friends of the given user, in the given graph."""
    return set(graph.neighbors(user))

def friends_of_friends(graph, user):
    """Returns a set of friends of friends of the given user, in the given graph. The result does not include the user nor their friends """
    fof = set()
    f = friends(graph, user)
    for fren in f:
        friends = friends(fren)  # name conflict!
        fof = fof | friends
    g = (fof - f)
    g.remove(user)
    return g

friends_of_friends(rj, "Mercutio")


# Traceback (most recent call last):
#  File "name_conflict2.py", line 38, in <module>
#    friends_of_friends(rj, "Mercutio")
#  File "name_conflict2.py", line 30, in friends_of_friends
#    f = friends(graph, user)
#UnboundLocalError: local variable 'friends' referenced before assignment

# In line 32, friends is being assigned.  Python assumes it must be a local variable.
# You cannot use a local variable before you assign it.
# Python doesn't even care that the variable is defined globally
# See unbound_local.py for a minimal example of this problem
