import networkx as nx

rj = nx.Graph()
rj.add_edge("Juliet", "Nurse")
rj.add_edge("Juliet", "Tybalt")
rj.add_edge("Juliet", "Capulet")
rj.add_edge("Juliet", "Friar Laurence")
rj.add_edge("Juliet", "Romeo")
rj.add_edge("Capulet", "Tybalt")
rj.add_edge("Capulet", "Paris")
rj.add_edge("Capulet", "Escalus")
rj.add_edge("Romeo", "Friar Laurence")
rj.add_edge("Romeo", "Benvolio")
rj.add_edge("Romeo", "Montague")
rj.add_edge("Romeo", "Mercutio")
rj.add_edge("Montague", "Benvolio")
rj.add_edge("Montague", "Escalus")
rj.add_edge("Mercutio", "Escalus")
rj.add_edge("Mercutio", "Paris")
rj.add_edge("Escalus", "Paris")


def friends(graph, user):
    """Returns a set of the friends of the given user, in the given graph."""
    return set(graph.neighbors(user))

def friends_of_friends(graph, user):
    """Returns a set of friends of friends of the given user, in the given graph. The result does not include the user nor their friends """
    fof = set()
    f = friends(graph, user)
    for fren in f:
        friendset = friends(fren)
        fof = fof | friendset
    g = (fof - f)
    g.remove(user)
    return g



myval=["Mercutio"]
print friends_of_friends(rj, myval)

# Traceback (most recent call last):
#  File "nx_error.py", line 41, in <module>
#    print friends_of_friends(rj, myval)
#  File "nx_error.py", line 30, in friends_of_friends
#    f = friends(graph, user)
#  File "nx_error.py", line 25, in friends
#    return set(graph.neighbors(user))
#  File "/Library/Frameworks/EPD64.framework/Versions/7.3/lib/python2.7/site-packages/networkx/classes/graph.py", line 978, in neighbors
#    return list(self.adj[n])


# How many stack frames are referenced?
# FOUR:
# One for the global environment
# One for the function call to friends_of_friends
# One for the function call to friends
# One for the function call to neighbors

# Where did the error actually get noticed?
#  (In the networkx library!)

# Where was the original cause of the problem?
# A spelling error in global program

# The error tells you the location of the symptom, not the cause!

# Debugging approach:
# Read the error message, and check the last stack frame.
# That stack frame is in another library.  Always assume first that an external library is
# implemented correctly.  It's tempting t blame someone else's code, but remember that
# the code you just wrote has been tested zero times.  The library you are using
# has perhaps been tested thousands of times by thousands of people.
# Keep looking backwards in the stack frames until you find your code.
# Print the variables, check the types.
